/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.robokind.demo.robot.replication;

import java.nio.ByteBuffer;
import java.util.List;
import org.jflux.api.core.Adapter;
import org.jflux.api.core.event.BasicEvent;
import org.jflux.api.core.event.Event;
import org.jflux.avrogen.EventListRecord;
import org.jflux.avrogen.EventRecord;

/**
 *
 * @author Matthew Stevenson
 */
public class EventDecoder<H,T> implements 
        Adapter<Event<H,ByteBuffer>,Event<H,T>>{
    private Adapter<ByteBuffer,T> myDataDecoder;
    
    public EventDecoder(Adapter<ByteBuffer,T> dataEncoder){
        myDataDecoder = dataEncoder;
    }
    
    public void setDataEncoder(Adapter<ByteBuffer,T> dataEncoder){
        myDataDecoder = dataEncoder;
    }
    
    @Override
    public Event<H, T> adapt(Event<H,ByteBuffer> a) {
        if(myDataDecoder == null){
            return null;
        }
        ByteBuffer b = a.getData();
        H h = a.getHeader();
        T t = myDataDecoder.adapt(b);
        return new BasicEvent<H,T>(h, t);
    }
    
    public static class EventListDecoder implements 
            Adapter<EventListRecord,List<EventRecord>> {
        
        @Override
        public List<EventRecord> adapt(EventListRecord a) {
            if(a == null){
                return null;
            }
            return a.getData();
        }
    }
}
