/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.robokind.demo.robot.replication.lifecycle;

import java.util.ArrayList;
import java.util.List;
import org.jflux.api.core.config.Configuration;
import static org.robokind.impl.messaging.config.RKMessagingConfigUtils.*;
import static org.robokind.impl.messaging.utils.ConnectionManager.*;
import static org.robokind.impl.messaging.config.MessagingLifecycleGroupConfigUtils.*;
import static org.robokind.api.common.lifecycle.config.RKManagedGroupConfigUtils.*;

/**
 *
 * @author Matthew Stevenson
 */
public class ReplicationReceiverGroupLifecycleUtils {
    public final static String REPLICATION_DESTINATION_ID = "replicationDestinationId";
    public final static String REPLICATION_CONNECTION_ID = "replicationConnectionId";
    public final static String REPLICATION_SESSION_ID = "replicationSessionId";
    public final static String REPLICATION_ROUTER_ID = "replicationRouterId";
    public final static String EVENT_LIST_DECODER_ID = "eventListDecoderId";
    public final static String REPLICATION_RECEIVER_ID = "replicationReceiverId";
    public final static String RECEIVER_LIST_DECODER_LINK_ID = "receiverListDecoderLinkId";
    public final static String LIST_DECODER_ROUTER_LINK_ID = "listDecoderRouterLinkId";
    
    public final static String LINK_DECODER_ID = "decoderLinkId";
    public final static String LINK_ROUTE_ID = "routeLinkId";
    
    public final static String GROUP_TYPE = "ReplicationReceiverGroup";
    private final static String theIdFormat = "%s/" + GROUP_TYPE + "/%s";
    
    public static String id(String groupId, String part){
        return String.format(theIdFormat, groupId, part);
    }
    
    public static List<Configuration<String>> 
            getReplicationReceiverLifecycleConfigs(String groupId){
        return ReplicationReceiverLifecycleUtils.getLifecycleConfigs(
                REPLICATION_ROUTER_ID, id(groupId, REPLICATION_ROUTER_ID), 
                EVENT_LIST_DECODER_ID, id(groupId, EVENT_LIST_DECODER_ID), 
                REPLICATION_RECEIVER_ID, id(groupId, REPLICATION_RECEIVER_ID), 
                PROP_DESTINATION_ID, id(groupId, REPLICATION_DESTINATION_ID), 
                PROP_CONNECTION_ID, id(groupId, REPLICATION_SESSION_ID),
                id(groupId, RECEIVER_LIST_DECODER_LINK_ID),
                id(groupId, LIST_DECODER_ROUTER_LINK_ID));
    }
    
    public static List<Configuration<String>> getJMSLifecycleConfigs(
            String groupId, String destinationConfId, String connectionConfId){
        List<Configuration<String>> l = new ArrayList();
        l.add(makeSelfBuildingLifecycle(buildDestinationLifecycleConfig(
                destinationConfId,id(groupId, REPLICATION_DESTINATION_ID))));
        l.add(makeSelfBuildingLifecycle(buildConnectionLifecycleConfig(
                connectionConfId, id(groupId, REPLICATION_CONNECTION_ID))));
        l.add(makeSelfBuildingLifecycle(buildSessionLifecycleConfig(
                id(groupId, REPLICATION_CONNECTION_ID), 
                id(groupId, REPLICATION_SESSION_ID))));
        return l;
    }
    
    public static Configuration<String> getReplicationDecoderLinkLifecycleConfig(
            String groupId, String decoderId, String encodeConfigId){
        return ReplicationReceiverLifecycleUtils.buildDecoderRouteLinkLifecycleConfig(
                LINK_DECODER_ID, id(groupId, LINK_DECODER_ID + "/" + decoderId), 
                REPLICATION_ROUTER_ID, id(groupId, REPLICATION_ROUTER_ID), 
                SERIALIZATION_CONFIG, encodeConfigId);
    }
    
    public static Configuration<String> getReplicationRouteLinkLifecycleConfig(
            String groupId, String linkId, String routingKey,
            String consumerIdKey, String consumerId){
        return ReplicationReceiverLifecycleUtils.buildEventRouteLinkLifecycleConfig(
                LINK_DECODER_ID, id(groupId, LINK_ROUTE_ID + "/" + linkId), 
                REPLICATION_ROUTER_ID, id(groupId, REPLICATION_ROUTER_ID), 
                consumerIdKey, consumerId, routingKey);
    }
}
