/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.robokind.demo.robot.replication.messaging;

import org.jflux.api.core.Adapter;
import org.jflux.avrogen.DoubleRecord;
import org.robokind.api.common.position.NormalizedDouble;

/**
 *
 * @author matt
 */
public class PortableNormalizedDouble extends NormalizedDouble {
    private DoubleRecord myDoubleRecord;
    
    public PortableNormalizedDouble(DoubleRecord record){
        super(record.getValue());
        myDoubleRecord = record;
    }
    
    public PortableNormalizedDouble(NormalizedDouble normDouble){
        super(normDouble.getValue());
        if(normDouble instanceof PortableNormalizedDouble){
            myDoubleRecord = ((PortableNormalizedDouble)normDouble).getRecord();
        }else{
            myDoubleRecord = new DoubleRecord();
            myDoubleRecord.setValue(this.getValue());
        }
    }
    
    public DoubleRecord getRecord(){
        return myDoubleRecord;
    }
    
    public static class MessageRecordAdapter 
            implements Adapter<NormalizedDouble, DoubleRecord>{
        @Override
        public DoubleRecord adapt(NormalizedDouble a) {
            if(a == null){
                throw new NullPointerException();
            }
            return new PortableNormalizedDouble(a).getRecord();
        }
    }
    
    public static class RecordMessageAdapter 
            implements Adapter<DoubleRecord, NormalizedDouble>{
        @Override
        public NormalizedDouble adapt(DoubleRecord a) {
            if(a == null){
                throw new NullPointerException();
            }
            return new PortableNormalizedDouble(a);
        }
    }
    
}
